#include <iostream>
#include <vector>

using namespace std;

struct Seq {
    long long l;
    long long r;
    char d;

    Seq(int l, int r, char d) {
        this -> l = l;
        this -> r = r;
        this -> d = d;
    }
};

int main() {
    int n;
    cin >> n;

    vector<int> a(n);
    vector<Seq> seqs;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    seqs.push_back(Seq(0, 0, 'n'));

    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i - 1]) {
            if (seqs[seqs.size() - 1].d != 'd') {
                seqs[seqs.size() - 1].d = 'u';
                seqs[seqs.size() - 1].r = i;
            } else {
                seqs.push_back(Seq(i - 1, i, 'u'));
            }
        } else if (a[i] < a[i - 1]) {
            if (seqs[seqs.size() - 1].d != 'u') {
                seqs[seqs.size() - 1].d = 'd';
                seqs[seqs.size() - 1].r = i;
            } else {
                seqs.push_back(Seq(i - 1, i, 'd'));
            }
        } else {
            seqs.push_back(Seq(i, i, 'n'));
        }
    }

    long long ans = 0;

    for (int i = 0; i < seqs.size(); ++i) {
        if (i < seqs.size() - 1 && seqs[i + 1].d == 'd' && seqs[i].d == 'u' && seqs[i + 1].l == seqs[i].r) {
            ans += (seqs[i + 1].r - seqs[i].l + 1) * (seqs[i + 1].r - seqs[i].l + 2) / 2;
            if (i > 0 && seqs[i - 1].r == seqs[i].l) {
                ans--;
            }

            ++i;
            continue;
        } else {
            ans += (seqs[i].r - seqs[i].l + 1) * (seqs[i].r - seqs[i].l + 2) / 2;
            if (i > 0 && seqs[i - 1].r == seqs[i].l) {
                ans--;
            }
        }
    }

    cout << ans;

    return 0;
}
