#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<pair<vector<int>, int>> v(1000000, make_pair(vector<int>(), -1));
    vector<pair<int, int>> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }

    sort(a.begin(), a.end());

    for (int i = 0; i < n; ++i) {
        vector<int> ps;
        v[a[i].first].second = a[i].second;

        for (int j = 2; j <= sqrt(a[i].first); ++j) {
            if (a[i].first % j == 0) {
                bool f = true;

                for (int k = 0; k < ps.size(); ++k) {
                    if (j % ps[k] == 0) {
                        f = false;
                        break;
                    }
                }

                if (f) {
                    ps.push_back(j);

                    if (v[a[i].first / j].second != -1) {
                        v[a[i].first / j].first.push_back(a[i].first);
                    }
                }
            }
        }
    }

    vector<vector<int>> graph(n);

    for (int i = 0; i < v.size(); ++i) {
        if (v[i].second != -1) {
            for (int vert : v[i].first) {
                graph[vert].push_back(v[i].second);
                graph[v[i].second].push_back(vert);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < graph[i].size(); ++j) {
            cout << graph[i][j] << " ";
        }


    }

    return 0;
}
