#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<char>> sits(n, vector<char>(6));

    int cnt = 0;
    string in;

    for (int i = 0; i < n; ++i) {
        cin >> in;

        sits[i][0] = in[0];
        sits[i][1] = in[1];
        sits[i][2] = in[2];
        sits[i][3] = in[3];
        sits[i][4] = in[4];
        sits[i][5] = in[5];

        if (sits[i][0] != sits[i][5]) {
            cnt++;
            sits[i][0] = 'X';
            sits[i][5] = 'X';
        }

        if (sits[i][1] != sits[i][4]) {
            cnt++;
            sits[i][1] = 'X';
            sits[i][4] = 'X';
        }

        if (sits[i][2] != sits[i][3]) {
            cnt++;
            sits[i][2] = 'X';
            sits[i][3] = 'X';
        }
    }

    if (cnt > m) {
        cout << "Impossible";
        return 0;
    }

    if (m + cnt > n * 6) {
        cout << "Impossible";
        return 0;
    }

    m -= cnt;
    int j = 0;

    if (m % 2 == 1) {
        cout << "Impossible";
        return 0;
    }

    while (m > 0) {
        if (sits[j][0] == '.') {
            sits[j][0] = 'X';
            sits[j][5] = 'X';
            m -= 2;
        }

        if (m == 0) {
            break;
        }

        if (sits[j][1] == '.') {
            sits[j][1] = 'X';
            sits[j][4] = 'X';
            m -= 2;
        }

        if (m == 0) {
            break;
        }

        if (sits[j][2] == '.') {
            sits[j][2] = 'X';
            sits[j][3] = 'X';
            m -= 2;
        }

        if (m == 0) {
            break;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << sits[i][0] << sits[i][1] << sits[i][2] << sits[i][3] << sits[i][4] << sits[i][5] << endl;
    }

    return 0;
}
