#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

vector<int> a;
vector<int> t;

long long f(int mid, int n) {
    long long ans = 0;

    for (int i = 0; i < n; ++i) {
        if (mid - a[i] - t[i] > 33) {
            return 3 * 1e9;
        }

        if (mid >= a[i] + t[i]) {
            ans += pow(2, mid - a[i] - t[i] + 1);
        } else if (mid >= a[i]) {
            ans++;
        }
    }

    return ans;
}

int main() {
    int n, m;
    cin >> n >> m;

    a.resize(n);
    t.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    long long l = 0;
    long long r = 3 * 1e9;
    long long mid;

    while (r - l > 1) {
        mid = (l + r) / 2;

        if (f(mid, n) >= m) {
            r = mid;
        } else {
            l = mid;
        }
    }

    if (f(r, n) == m) {
        cout << r;
    } else {
        cout << -1;
    }

    return 0;
}