#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

vector<int> a;
vector<pair<int, int>> qs;

int solveM3() {
    if (qs[0].second % 3 == qs[1].second % 3) {
        return min(qs[0].second, min(qs[2].second, qs[1].second)) / 3 + 1;
    } else {
        return 0;
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    a.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sort(a.begin(), a.end());

    qs.push_back(make_pair(a[0], 1));

    for (int i = 1; i < n; ++i) {
        if (qs[qs.size() - 1].first == a[i]) {
            qs[qs.size() - 1].second++;
        } else {
            qs.push_back(make_pair(a[i], 1));
        }
    }

    if (qs.size() == 1) {
        cout << 1;
        return 0;
    } else if (qs.size() == 2) {
        if (qs[0].second % 3 == 0) {
            cout << 1;
        } else {
            cout << 0;
        }

        return 0;
    } else if (qs.size() == 3) {
        cout << solveM3();
        return 0;
    }

    vector<vector<int>> dp(qs.size() - 2);

    return 0;
}